/*

 Lancia Weber/Marelli IAW ECM tests
 
 Juha Niinikoski 7.08.2003


*/

//****************
//include header files

#include	<pic.h>
#include	<conio.h>
#include	<stdlib.h>
#include 	<stdio.h>
#include	<ctype.h>

#include	"lancia.h"


//	__CONFIG(UNPROTECT|BODEN|FOSC1|BKBUG|WRT|CPD);		// CPU config bits v7.xx
	__CONFIG(UNPROTECT&WDTDIS&BOREN&HS&DEBUGDIS&WRTDIS&DUNPROT&PWRTEN&LVPDIS); // config bits for v8.01

/* Global variables */

#define		two_row	1				// two row display panel (2 controllers)

unsigned char 	io_sw;					// output port and display select

const char version[] = {"Version 21.08.2003"};	// system version info


/* Include files */

#include	"cserial.h"
#include	"max3100.h"

#include	"max3100.c"
#include	"timers.c"
#include	"lcd8.c"
#include	"cserial.c"


//***************************
// Converter Main
//***************************

void main( void )
{

char dly;
unsigned char c;
unsigned char chr;

/* Init IO Ports */

// Set up PORTA
	TRISA = TRISA_INIT;
	PORTA = PORTA_INIT;

// Set up PORTB
	TRISB = TRISB_INIT;
	PORTB = PORTB_INIT;

// Set up PORTC
	TRISC = TRISC_INIT;
	PORTC = PORTC_INIT;

// Set up PORTD
	TRISD = TRISD_INIT;
	PORTD = PORTD_INIT;

// Set up PORTE
	TRISE = TRISE_INIT;
	PORTE = PORTE_INIT;

// Set up TMR1 for time expired operation
	T1CKPS1 = 1;		// prescaler = 4 ==> TMR1 Clock = 1 MHz

// Init 16F877 UART with set speed to 7812,5 Bd for Marelli Weber ECM communications
	serial_setup(124);

// init LCD controller
	io_sw = LCD1;
	initlcd();


	io_sw = MAX1;		// Serial 1 = Terminal
	MAX3100_init();		// init SPI controller & MAX3100 38400 bd
 	putst("Lancia ECU Tests Juha Niinikoski ");
 	putst(version);
 	putst("\n\n");

	io_sw = LCD1;		// LCD controller 1, line 1 & 2
	putst(version);

	set_cur_lcd(LINE_2);
	putst("Data transmitted");
	set_cur_lcd(LINE_3);
	putst("    To ECM");
	set_cur_lcd(LINE_4);
	putst("    From ECM");

	io_sw = MAX1;		// Serial 1
	putst(" System started\n\n");

	for(dly = 0; dly < 5; dly++)	// show Hello message for a while
		{
		delay( 250 );
		}



// start main process loop
for (;;)
	{

if(J26 == 0)					// run terminal (manual) code ig J26 is closed
	{
	LEDB = 1;
	io_sw = UART;
	if (keypressed() == 1)			// receive characters ECU
		{
		LEDC = 1;
		c = getch();

		io_sw = MAX1;			// retransmit to terminal in hex format
		putchhex(c);
		putch(' ');

		io_sw = LCD1;
		set_cur_lcd(LINE_4);
		putchhex(c);
		LEDC = 0;
		}

	io_sw = MAX1;

	if(MAX3100_rxrdy())			// check if rx ready at MAX1
		{
		LEDA = 1;
		chr = get2hex();
		putch(' ');
		putchhex(chr);
		putst(" > ECU\n\n");

		io_sw = UART;
		putch(chr);			// transmit to ECM

		io_sw = LCD1;
		set_cur_lcd(LINE_3);
		putchhex(chr);

		LEDA = 0;
		}

	}

else						// run transpaernt (binary) baud rate converter
	{
	LEDB = 0;
	}
	io_sw = UART;
	if (keypressed() == 1)			// receive characters ECU
		{
		LEDC = 1;
		c = getch();
		io_sw = MAX1;			// retransmit to terminal in hex format
		putch(c);

		io_sw = LCD1;
		set_cur_lcd(LINE_4);
		putchhex(c);
		LEDC = 0;

		LEDC = 0;
		}

	io_sw = MAX1;
	if(MAX3100_rxrdy())			// check if rx ready at MAX1
		{
		LEDA = 1;
		chr = getch();
		io_sw = UART;
		putch(chr);			// transmit to ECM

		io_sw = LCD1;
		set_cur_lcd(LINE_3);
		putchhex(chr);

		LEDA = 0;
		}

	}

}
