/*
 *	Header file for JNi ECM PC-I(/O & Display board
 *	This file defines only board specific signals
 *	Other definitions from Microchip 1687x.h file
 *
 * 	Juha Niinikoski 21.08.2003
 *
 *
 */

#define	PIC_CLK 16000000

/*	Port A signals	*/

#define PORTA_INIT	0b00000000
#define	TRISA_INIT	0b00010011	/* Jumper / switch inputs*/

#define J3_3_4		RA0		/*  0 if closed */
#define J3_1_2		RA1		/*  0 if closed */
#define J26		RA4		/* J26 Jumper. 0 if closed */


/*	Port B signals	*/

#define PORTB_INIT	0b00000000	/* PORTB init data */
#define TRISB_INIT	0b00000001

#define IRQ_SERIAL1	RB0	/* Serial 1 MAX3100 IRQ */
#define CS_SERIAL1	RB1	/* Serial 1 CS */

#define LCD_E		RB5	/* LCD E signal */
#define LCD_E1		RB5	/* LCD E1 signal */
#define LCD_RW		RB6	/* LCD R/W signal */
#define LCD_RS		RB7	/* LCD RS signal */


/*	Port C signals	*/

/* RC6 - RC7 are reserved for serial IO */
/* RC3 - RC5 are reserved for serial IO */
/* RC0 - RC3 are LED outputs */

#define PORTC_INIT	0b00000000	/* PORTC init data */
#define TRISC_INIT	0b10010000

#define	LEDC		RC0	/* LED C Green*/
#define	LEDB		RC1	/* LED B Yellow*/
#define	LEDA		RC2	/* LED A Red*/


/*	Port D signals	*/

/* Port D = LCD interface */

#define PORTD_INIT	0b00000000	/* PORTD init data */
#define TRISD_INIT	0b00000000

#define LCD_DATA	PORTD	/* LCD 8-bit data bus */
#define LCD_TRIS	TRISD	/* LCD data direction */ 

/*	Port E signals	*/

/* Port E used for analog inputs */

#define PORTE_INIT	0b00000000	/* PORTE init data */
#define TRISE_INIT	0b00000100	/* !TRISE controls also PORTD mode */


/* Output switch definitions */

#define UART	0	// 16F877 UART
#define MAX	0x10
#define	MAX1	0x11	// MAX3100 serial 1
#define MAX2	0x12	// MAX3100 serial 2
#define LCD	0x20
#define LCD1	0x21	// LCD 1 (upper half)
#define LCD2	0x22	// LCD 2 (lower half)

