/*   max3100.h - MAX 3100 SPI serial I/O definitions   */
/*   version 0.1, 29.4.2001, Semantics Oy, Tauno Voipio   */
/* changet to 1.8432 MHz XTAL Juha Niinikoski 30.09.2002 */


#define RDDAT  (0 << 6)   /* cbyte write: read data */
#define RDCFG  (1 << 6)   /* cbyte write: read configuration */
#define WRDAT  (2 << 6)   /* cbyte write: write data */
#define WRCFG  (3 << 6)   /* cbyte write: write configuration */

#define RXRDY  (1 << 7)   /* cbyte read: receiver ready */
#define TXRDY  (1 << 6)   /* cbyte read: transmitter ready */

#define FDS    (1 << 5)   /* cfg/cbyte: receive FIFO disable */
#define SHDN   (1 << 4)   /* cfg/cbyte: shutdown */
#define TIE    (1 << 3)   /* cfg/cbyte: transmit interrupt enable */
#define RIE    (1 << 2)   /* cfg/cbyte: receive interrupt enable */
#define PIE    (1 << 1)   /* cfg/cbyte: P bit (ninth data) interrupt enable */
#define FIE    (1 << 0)   /* cfg/cbyte: activity/framing interrupt enable */

#define IRDA   (1 << 7)   /* cfg/dbyte: IRDA mode */
#define ST2    (1 << 6)   /* cfg/dbyte: two stop bit select */
#define PBE    (1 << 5)   /* cfg/dbyte: P bit (ninth data) enable */
#define DL7    (1 << 4)   /* cfg/dbyte: data length 7 bits */

#define BR1152 (0 << 0)   /* cfg/dbyte: bit rate 115200 */
#define BR576  (1 << 0)   /* cfg/dbyte: bit rate 57600 */
#define BR288  (2 << 0)   /* cfg/dbyte: bit rate 28800 */
#define BR144  (3 << 0)   /* cfg/dbyte: bit rate 14400 */
#define BR72   (4 << 0)   /* cfg/dbyte: bit rate 7200 */
#define BR36   (5 << 0)   /* cfg/dbyte: bit rate 3600 */
#define BR18   (6 << 0)   /* cfg/dbyte: bit rate 1800 */
#define BR9    (7 << 0)   /* cfg/dbyte: bit rate 900 */
#define BR384  (8 << 0)   /* cfg/dbyte: bit rate 38400 */
#define BR192  (9 << 0)   /* cfg/dbyte: bit rate 19200 */
#define BR96   (10 << 0)  /* cfg/dbyte: bit rate 9600 */
#define BR48   (11 << 0)  /* cfg/dbyte: bit rate 4800 */
#define BR24   (12 << 0)  /* cfg/dbyte: bit rate 2400 */
#define BR12   (13 << 0)  /* cfg/dbyte: bit rate 1200 */
#define BR6    (14 << 0)  /* cfg/dbyte: bit rate 600 */
#define BR3    (15 << 0)  /* cfg/dbyte: bit rate 300 */

#define RTSE   (1 << 2)   /* dat/cbyte write: update only RTS */
#define RAFE   (1 << 2)   /* dat/cbyte read: rx active / framing error */
#define RTS    (1 << 1)   /* dat/cbyte: request to send */
#define PBIT   (1 << 0)   /* dat/cbyte: P bit (ninth data) */

