/*

 ECM PC-I/O & Display board timer routines

 Juha Niinikoski 21.08.2003

*/

//**********************
// TMR0 used for delays
//**********************


/* Delays a multiple of 1 milliseconds at 16 MHz  TMR0 timer */
void delay( char millisec )
{
    OPTION = 4;  /* prescaler divide by 32 */
    do  {
        TMR0 = 0;
        while ( TMR0 < 125); // 125 * 8 = 1000
    } while ( -- millisec > 0);
}

/* Delays a multiple microseconds + start delay at 16 MHz  TMR0 timer */
void udelay( char usec )
{
	OPTION = 1;  /* prescaler divide by 4 = 1MHz clock for TMR0 */
	TMR0 = 0;
	while ( TMR0 < usec )
	{
	}

}

//*********************************
// TMR1 used for expiration delays
//*********************************


void set_idle_timer(VOID)	// set timer1 for 1700 uS expiration time. 10 bits = 1280 uS
	{
	TMR1ON = 0;
	TMR1IF = 0;
	TMR1L = 0x5B;		// 1700 mS = 0xFFFF - 0x06A4 = 0xF95B
	TMR1H = 0xF9;
	TMR1ON = 1;
	}


void set_timeout(void)		// set timer1 for max 65 ms delay
	{
	TMR1ON = 0;
	TMR1IF = 0;
	TMR1L = 0;		// 65535uS = 65 mS
	TMR1H = 0;
	TMR1ON = 1;
	}

